"""
Will Van Rensselaer (wavanrensselaer@wpi.edu)
MU 2300 - Final Project
"""

import argparse
import generator
import mido
from mido import MidiFile
from mido import Message

parser = argparse.ArgumentParser()
parser.add_argument('output', type=str, help="output file")
parser.add_argument('--bpm', type=int, help="beats-per-minute", default=120)
parser.add_argument('--key', type=str, help="key signature", default="C",
	choices=[
		'A', 'A#m', 'Ab', 'Abm', 'Am',
		'B', 'Bb', 'Bbm', 'Bm',
		'C', 'C#', 'C#m', 'Cb', 'Cm',
		'D', 'D#m', 'Db', 'Dm',
		'E', 'Eb', 'Ebm', 'Em',
		'F', 'F#', 'F#m', 'Fm',
		'G', 'G#m', 'Gb', 'Gm'
	]
)
parser.add_argument('--beats', type=int, help="number of beats in loop (1 beat is a quarter note)", default=16)
parser.add_argument('--random', type=bool, help="generate random notes", default=False)
args = parser.parse_args()

file = generator.create(
	args.output,
	mido.bpm2tempo(args.bpm),
	args.key,
	args.beats,
	args.random
)
#print()
#generator.print_file(file)
file.save(args.output)
