"""
Will Van Rensselaer (wavanrensselaer@wpi.edu)
MU 2300 - Final Project
"""

import json
import random

BEAT = 480 # Ticks per beat

WHOLE     = int(BEAT * 4)
HALF      = int(BEAT * 2)
QUARTER   = int(BEAT)
EIGHTH    = int(BEAT / 2)
SIXTEENTH = int(BEAT / 4)

GLOBAL_OCTAVE = 0
C4 = 72

notes = {
	'Ab': -4,
	'A':  -3,
	'A#': -2,
	'Bb': -2,
	'B':  -1,
	'B#':  0,
	'Cb': -1,
	'C':   0,
	'C#':  1,
	'Db':  1,
	'D':   2,
	'D#':  3,
	'Eb':  3,
	'E':   4,
	'E#':  5,
	'Fb':  4,
	'F':   5,
	'F#':  6,
	'Gb':  6,
	'G':   7,
	'G#':  8
}

progressions = [
	[0, 5],
	[0, 7],
	[0, 5, 7],
	[0, 5, 8],
	[0, 5, 0, 7],
	[0, 5, 0, 8],
	[0, 5, 7, 5],
	[5, 0, 5, 7]
]

GLOBAL_KEY = 'C'

keys = json.load(open('data/keys.json'))

def get_note(note, octave = 0):
	if not note in notes:
		raise Exception('Invalid note')

	value = C4 + notes[note] + octave * 12

	while value > 127:
		value -= 12

	while value < 0:
		value += 12

	return value

def get_note_in_key(note, octave = GLOBAL_OCTAVE, key = GLOBAL_KEY):
	if not key in keys:
		raise Exception('Invalid key')

	scale = keys[key]
	if 'alias' in scale:
		return get_note_in_key(note, octave, scale['alias'])

	if not note in scale:
		raise Exception('Invalid note name')

	return get_note(scale[note], octave)

def random_note(octave = GLOBAL_OCTAVE, key = GLOBAL_KEY):
	return get_note_in_key(
		random.choice(list(notes.keys())),
		octave,
		key
	)

def get_key_note(key = GLOBAL_KEY):
	return key[:-1] if key[len(key) - 1] == 'm' else key
